%global PREFIX /usr/
%global BINDIR %{PREFIX}/bin
%global DOMAIN github.com
%global ORG kata-containers
%global PROJECT runtime
%global IMPORTNAME %{DOMAIN}/%{ORG}/%{PROJECT}

%if %{?oraclelinux} == 7
%global DEFAULT_QEMU /usr/bin/qemu-system-x86_64
%else
%global DEFAULT_QEMU /usr/libexec/qemu-kvm
%endif

%if 0%{?suse_version}
%define LIBEXECDIR %{_libdir}
%else
%define LIBEXECDIR %{_libexecdir}
%endif

%undefine _missing_build_ids_terminate_build
%define  debug_package %{nil}

Name:      kata-runtime
Version:   1.11.5
Release:   1%{?dist}
Source0:   %{name}-%{version}.tar.bz2
Patch0:    kata_sysrq_support.patch.txt
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:    Oracle America
Summary:   Kata containers OCI compatible runtime
Group:     Development/Tools
License:   Apache-2.0

BuildRequires: git
BuildRequires: golang >= 1.13.15
%if 0%{?suse_version} && 0%{?is_opensuse}
BuildRequires: openSUSE-release
%endif
BuildRequires: libselinux-devel

Requires: kata-proxy >= 1.11.5
Requires: kata-shim >= 1.11.5
Requires: kata-ksm-throttler >= 1.11.5
%if %{?oraclelinux} == 7
Requires: qemu >= 2:2.9.0-9
%endif
%if %{?oraclelinux} == 8
Requires: qemu-kvm >= 2:2.9.0-9
%endif
Requires: kernel-uek-container >= 4.14.14-4
Requires: kata-image >= 1.11.5

%description
Kata Containers runtime component leverages the virtcontainers package to provide a high-performance standards-compliant runtime that creates hardware-virtualized containers. The runtime is OCI-compatible, CRI-O-compatible, and Containerd-compatible, allowing it to work seamlessly with both Docker and Kubernetes respectively.

%prep
%setup 

# process the patches
%patch0

%build
export GOPATH=$HOME/rpmbuild/BUILD/go/

mkdir -p $HOME/rpmbuild/BUILD/go/src/%{DOMAIN}/%{ORG}
ln -s %{_builddir}/kata-runtime-%{version} $HOME/rpmbuild/BUILD/go/src/%{IMPORTNAME}
cd $HOME/rpmbuild/BUILD/go/src/%{IMPORTNAME}
make \
	QEMUPATH=%{DEFAULT_QEMU} \
	FEATURE_SELINUX=yes

%install
export GOPATH=$HOME/rpmbuild/BUILD/go/

cd $HOME/rpmbuild/BUILD/go/src/%{IMPORTNAME}
make \
    PREFIX=/usr/ \
    DESTDIR=%{buildroot} \
    QEMUPATH=%{DEFAULT_QEMU} \
    SKIP_GO_VERSION_CHECK=1 \
    install
sed -i -e '/^initrd =/d' %{buildroot}/usr/share/defaults/kata-containers/configuration.toml

%files
%license LICENSE THIRD_PARTY_LICENSES.txt
%defattr(-,root,root,-)
/usr/bin/kata-runtime
/usr/bin/kata-collect-data.sh
/usr/bin/containerd-shim-kata-v2
/usr/share/defaults/kata-containers/configuration.toml
/usr/share/defaults/kata-containers/configuration-fc.toml
/usr/share/defaults/kata-containers/configuration-qemu.toml
/usr/share/defaults/kata-containers/configuration-acrn.toml
/usr/share/defaults/kata-containers/configuration-clh.toml
/usr/share/defaults/kata-containers/configuration-qemu-virtiofs.toml
/usr/share/bash-completion/completions/kata-runtime
/usr/libexec/kata-containers/kata-netmon

%changelog
* Sat Nov 14 2020 Olcne-Builder Jenkins <olcne-builder_us@oracle.com> - 1.11.5-1
- Added Oracle Specific Files For kata-runtime
